#pragma once

#include "Stage.h"


enum STAGEOPCODE
{
	SOP_NEW = 0, //  
	SOP_DELETE, //  
	SOP_SAVE, //  

	_END_STAGEOPCODE_, // ׿
};


namespace PackageManager
{
	class AFX_EXT_CLASS CSMEPackage
	{
	public:
		CSMEPackage(void);
		~CSMEPackage(void);

	public:
		
		// Ű ε
		bool LoadFromDisk( CStdioFile* pFile );

		// Ű 
		bool DumpToDisk( CStdioFile* pFile = NULL );

		// б   
		const CStage* GetCurrentStage();

		// Ⱑ  
		CStage* GetCurrentStageWriteable();

		//  ó
		bool ProcessStage( STAGEOPCODE sopCode, int nStageUID = -1 );

	protected:
		// UID  Stage ã
		CStage* FindStage( int nStageUID );

	protected:
		// stage Ʈ
		list< CStage > m_listOfStage;
		
		//   
		CStage m_currentStage;

		CString m_strPathName;
	};
};