#pragma once

#define FIRST -1
#define LAST -2

typedef enum
{
	TOOL_SELECT,
	TOOL_PEN,
	TOOL_LINE,
	TOOL_RECT,
	TOOL_FILL,
	TOOL_ERASER
} ToolType;

typedef enum
{
	NO_DATA			= 0,
	FG				= ' ',
	TARGET			= 'T',
	WALL			= '#',
	BURDEN			= 'O',
	BURDENTARGET	= 'b',
	PORTER			= '@',
	PORTERTARGET	= 't',
	BG				= '.'
}CellType;

typedef enum
{
	FIRSTSTAGE,
	LASTSTAGE,
	NEXTSTAGE,
	PREVSTAGE
} StageType;