// MainFrm.cpp : CMainFrame Ŭ 
//

#include "stdafx.h"
#include "SME.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_TOOL_SELECT, OnToolSelect)
	ON_COMMAND(ID_TOOL_PEN, OnToolPen)
	ON_COMMAND(ID_TOOL_LINE, OnToolLine)
	ON_COMMAND(ID_TOOL_RECT, OnToolRect)
	ON_COMMAND(ID_TOOL_FILL, OnToolFill)
	ON_COMMAND(ID_TOOL_ERASER, OnToolEraser)
	ON_COMMAND(ID_CELL_BURDEN, OnCellBurden)
	ON_COMMAND(ID_CELL_BURDENTARGET, OnCellBurdenTarget)
	ON_COMMAND(ID_CELL_FG, OnCellFG)
	ON_COMMAND(ID_CELL_PORTE, OnCellPorte)
	ON_COMMAND(ID_CELL_PORTERTARGET, OnCellPorterTarget)
	ON_COMMAND(ID_CELL_TARGET, OnCellTarget)
	ON_COMMAND(ID_CELL_WALL, OnCellWall)

	ON_UPDATE_COMMAND_UI(ID_TOOL_SELECT, OnUpdateToolSelect)
	ON_UPDATE_COMMAND_UI(ID_TOOL_PEN, OnUpdateToolPen)
	ON_UPDATE_COMMAND_UI(ID_TOOL_LINE, OnUpdateToolLine)
	ON_UPDATE_COMMAND_UI(ID_TOOL_RECT, OnUpdateToolRect)
	ON_UPDATE_COMMAND_UI(ID_TOOL_FILL, OnUpdateToolFill)
	ON_UPDATE_COMMAND_UI(ID_TOOL_ERASER, OnUpdateToolEraser)

	ON_UPDATE_COMMAND_UI(ID_CELL_BURDEN, OnUpdateCellBurden)
	ON_UPDATE_COMMAND_UI(ID_CELL_BURDENTARGET, OnUpdateCellBurdenTarget)
	ON_UPDATE_COMMAND_UI(ID_CELL_FG, OnUpdateCellFG)
	ON_UPDATE_COMMAND_UI(ID_CELL_PORTE, OnUpdateCellPorte)
	ON_UPDATE_COMMAND_UI(ID_CELL_PORTERTARGET, OnUpdateCellPorterTarget)
	ON_UPDATE_COMMAND_UI(ID_CELL_TARGET, OnUpdateCellTarget)
	ON_UPDATE_COMMAND_UI(ID_CELL_WALL, OnUpdateCellWall)	
	ON_UPDATE_COMMAND_UI(ID_STAGE_FIRST, OnUpdateStageFirst)
	ON_UPDATE_COMMAND_UI(ID_STAGE_LAST, OnUpdateStageLast)
	ON_UPDATE_COMMAND_UI(ID_STAGE_PREV, OnUpdateStagePrev)
	ON_UPDATE_COMMAND_UI(ID_STAGE_NEXT, OnUpdateStageNext)
	ON_UPDATE_COMMAND_UI(ID_STAGE_RESIZE, OnUpdateStageResize)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,   		//   ǥñ
	ID_INDICATOR_CAPS, ID_INDICATOR_NUM, ID_INDICATOR_SCRL, 
};


// CMainFrame /Ҹ

CMainFrame::CMainFrame()
{
	// TODO: ⿡  ʱȭ ڵ带 ߰մϴ.
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT,
						WS_CHILD |
						WS_VISIBLE |
						CBRS_TOP |
						CBRS_GRIPPER |
						CBRS_TOOLTIPS |
						CBRS_FLYBY |
						CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("   ߽ϴ.\n");
		return -1;  	//  ߽ϴ.
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
							sizeof(indicators) /
															sizeof(UINT)))
	{
		TRACE0(" ǥ  ߽ϴ.\n");
		return -1;  	//  ߽ϴ.
	}
	// TODO:   ŷ   Ϸ    Ͻʽÿ.
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	createToolBarCell();
	createToolBarTool();
	createToolBarStage();
	return 0;
}



void CMainFrame::createToolBarCell()
{
	if (!m_wndToolBarCell.CreateEx(this, TBSTYLE_FLAT,
							WS_CHILD |
							WS_VISIBLE |
							CBRS_TOP |
							CBRS_GRIPPER |
							CBRS_TOOLTIPS |
							CBRS_FLYBY |
							CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBarCell.LoadToolBar(IDR_TOOLBAR_CELL))
	{
		TRACE("Failed to create CellBar\n");
		return;
	}

	m_wndToolBarCell.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBarCell, AFX_IDW_DOCKBAR_BOTTOM);
}

void CMainFrame::createToolBarTool()
{
	if (!m_wndToolBarTool.CreateEx(this, TBSTYLE_FLAT,
							WS_CHILD |
							WS_VISIBLE |
							CBRS_LEFT |
							CBRS_GRIPPER |
							CBRS_TOOLTIPS |
							CBRS_FLYBY |
							CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBarTool.LoadToolBar(IDR_TOOLBAR_TOOL))
	{
		TRACE("Failed to create Tool\n");
		return;
	}

	m_wndToolBarTool.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBarTool, AFX_IDW_DOCKBAR_LEFT);
}

void CMainFrame::createToolBarStage()
{
	if (!m_wndToolBarStage.CreateEx(this, TBSTYLE_FLAT,
							WS_CHILD |
							WS_VISIBLE |
							CBRS_LEFT |
							CBRS_GRIPPER |
							CBRS_TOOLTIPS |
							CBRS_FLYBY |
							CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBarStage.LoadToolBar(IDR_TOOLBAR_STAGE))
	{
		TRACE("Failed to create Tool\n");
		return;
	}

	m_wndToolBarStage.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBarStage, AFX_IDW_DOCKBAR_TOP);
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs))
		return FALSE;
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return TRUE;
}


// CMainFrame 

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame ޽ ó

//================================================================
// IDR_TOOLBAR_TOOL
//================================================================
void CMainFrame::OnToolPen()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setToolType(TOOL_PEN);
}
void CMainFrame::OnToolSelect()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setToolType(TOOL_SELECT);
}
void CMainFrame::OnToolLine()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setToolType(TOOL_LINE);
}
void CMainFrame::OnToolRect()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setToolType(TOOL_RECT);
}
void CMainFrame::OnToolFill()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setToolType(TOOL_FILL);
}
void CMainFrame::OnToolEraser()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setToolType(TOOL_ERASER);
}

//================================================================
// IDR_TOOLBAR_CELL
//================================================================
void CMainFrame::OnCellBG()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(BG);
}
void CMainFrame::OnCellBurden()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(BURDEN);
}
void CMainFrame::OnCellBurdenTarget()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(BURDENTARGET);
}
void CMainFrame::OnCellFG()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(FG);
}
void CMainFrame::OnCellPorte()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(PORTER);
}
void CMainFrame::OnCellPorterTarget()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(PORTERTARGET);
}
void CMainFrame::OnCellTarget()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(TARGET);
}
void CMainFrame::OnCellWall()
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	m_pDoc->setCellType(WALL);
}

void CMainFrame::OnUpdateToolSelect(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateToolPen(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	pCmdUI->SetCheck(TRUE);
}

void CMainFrame::OnUpdateToolLine(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateToolRect(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateToolFill(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateToolEraser(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateCellBG(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getToolType() == BG)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellBurden(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == BURDEN)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellBurdenTarget(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == BURDENTARGET)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellFG(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == FG)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellPorte(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == PORTER)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellPorterTarget(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == PORTERTARGET)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellTarget(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == TARGET)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
void CMainFrame::OnUpdateCellWall(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	if (m_pDoc->getToolType() != TOOL_PEN)
	{
		pCmdUI->Enable(SW_HIDE);
		return ;
	}
	if (m_pDoc->getCellType() == WALL)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainFrame::OnUpdateStageFirst(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	int stageLevel = m_pDoc->getCurrentLevel();
	if (!m_pDoc->IsOpenedPackage() ||
		!m_pDoc->IsExistStage() ||
		stageLevel == 1)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateStageLast(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	int stageLevel = m_pDoc->getCurrentLevel();
	int stageCount = m_pDoc->getStageCount();
	if (!m_pDoc->IsOpenedPackage() ||
		!m_pDoc->IsExistStage() ||
		stageLevel == stageCount)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateStagePrev(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	int stageLevel = m_pDoc->getCurrentLevel();
	if (!m_pDoc->IsOpenedPackage() ||
		!m_pDoc->IsExistStage() ||
		stageLevel == 1)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateStageNext(CCmdUI* pCmdUI)
{
	m_pDoc = (CSMEDoc *) GetActiveDocument();
	int stageLevel = m_pDoc->getCurrentLevel();
	int stageCount = m_pDoc->getStageCount();
	if (!m_pDoc->IsOpenedPackage() ||
		!m_pDoc->IsExistStage() ||
		stageLevel == stageCount)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateStageResize(CCmdUI* pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsExistStage());
}


void CMainFrame::OnUpdateEditPaste(CCmdUI* pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	if (IsClipboardFormatAvailable(CF_TEXT))
	{
		::OpenClipboard(AfxGetMainWnd()->GetSafeHwnd());
		HGLOBAL hmem = ::GetClipboardData(CF_TEXT);
		char* ptr = (char*) ::GlobalLock(hmem);
		char* stageString = new char [strlen(ptr) + 1];
		strcpy(stageString, ptr);
		::GlobalUnlock(hmem);
		::CloseClipboard();
		if (0 == strncmp(stageString, ";stage", strlen(";stage")))
		{
			pCmdUI->Enable(TRUE);
		}
		else
		{
			pCmdUI->Enable(FALSE);
		}
		delete[] stageString;
	}
}

void CMainFrame::OnUpdateEditUndo(CCmdUI* pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsExistUndo());
}

void CMainFrame::OnUpdateEditRedo(CCmdUI* pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsExistRedo());
}

void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsModifiedCheck());
}
