// SMEDoc.h : CSMEDoc Ŭ ̽
//


#pragma once

#include "Package.h"
#include <vector>
#include <utility>

class CSMEDoc : public CDocument
	{
protected: // serialization ϴ.
	CSMEDoc();
	DECLARE_DYNCREATE(CSMEDoc)

	enum
		{
		MINUS = -1
		, RESET = 0
		, PLUS = 1
		};
	// Ư
public:

	// ۾
public:

	// 
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive &ar);

	// 
public:
	virtual ~CSMEDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &dc) const;
#endif

	const bool IsOpenedPackage() const
		{
		if (0 != m_package)
			{
			return true;
			}
		else
			{
			return false;
			}
		}
	const bool IsExistStage() const
		{
		if (0 != getCurrentStage())
			{
			return true;
			}
		else
			{
			return false;
			}
		}
	const bool IsExistUndoData() const
		{
		return false;
		}
	const int getCurrentLevel() const
		{
		return m_currentLevel;
		}
	const int getTotalLevel() const
		{
		return m_package->getTotalLevel();
		}
	const Stage * getCurrentStage() const
		{
		if (true == this->IsOpenedPackage())
			{
			if (0 != m_currentLevel)
				{
				return m_package->getStage(m_currentLevel);
				}
			}

		return 0;
		}
	void addStage(const int row = 10, const int column = 10, const int level = -1);
	const int getSelectTool() const
		{
		return m_selectTool;
		}
	void selectStartPos(const int row, const int column);
	void drawCellwithTool(int toolID, char cell, std::vector<std::pair<int, int> > &data);
	void drawPen(const int cell, const int row, const int column);
protected:
    void openPackage(CArchive &ar);
    void openPackage_1(CArchive &ar);
    void savePackage(CArchive &ar);
    void savePackage_1(CArchive &ar);

	void setModified(const int op);
	void setModifiedCount(const int op);
	int getModifiedCount()
		{
		return m_modifiedCount;
		}
	int m_modifiedCount;

	Package *m_package;
	int m_currentLevel;
	int m_newStageRow;
	int m_newStageColumn;
	int m_selectTool;
	std::pair<int, int> m_penPos;

	// ޽  Լ ߽ϴ.
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnStageMove(UINT uID);
	afx_msg void OnStageNew();
	afx_msg void OnStageNewsize();
	afx_msg void OnStageResize();
	afx_msg void OnStageCut();
	afx_msg void OnStageCopy();
	afx_msg void OnStagePaste();
	afx_msg void OnStageDelete();
	afx_msg void OnEditUndo();
	virtual void DeleteContents();
	afx_msg void OnFileClose();
};


