// added by leese 2006/05/16


#pragma once


#define			DEFAULT_STAGESIZE		8

//  ϰ ִ ͵ 
enum CellAttribute 
{ 
	BG = 0x00,					// ǿ
	TARGET_BURDEN = 0x01,       //   ġ  
	FG = 0x02,                  // ǳ
	TARGET = 0x04,              //   ġ
	WALL = 0x11,                // 
	BURDEN = 0x21,              // 
	PORTER = 0x40,              // 
	PORTER_TARGET = 0x44,       // ڰ  ߾ ġ 

	_END_CA_ = 0xFF             // ׿
};



//////////////////////////////////////////////////////////////////////////
//  Ŭ
class AFX_EXT_CLASS CStage
{
public:
	CStage(void);
	virtual ~CStage(void);

	// For STL
	//  
	CStage( const CStage& rhs );

    //  ε
	void operator = (const CStage& rhs)
	{
		CopyFrom( rhs );
	}

public:

	//     ˻
	bool HasValidStage(void) const;

	//  
	bool CreateStage( int nStageUID = -1,
		              int nWidth = DEFAULT_STAGESIZE,
					  int nHeight = DEFAULT_STAGESIZE );

	//  Ŭ
	void SetStageClear( bool bClear = false , int nMovementCount = 0 );

	//  ũ ȯ
	int GetStageSize(void) const;

	//  ũ ȯ
	void GetStageSize( int& nWidth, int& nHeight );

	// x,y ǥ Է شϴ   
	BYTE GetCell( int nXPos = 0, int nYPos = 0 ) const;

	// x,y ǥ Է شϴ   
	void SetCell( int nXPos = 0, int nYPos = 0, BYTE attr = BG );

	// 
	void Resize( int nWidthOffset = 0, int nHeightOffset = 0 );

	//  
	void LoadFromDisk( CStdioFile* pFile );
	void DumpToDisk( CStdioFile* pFile );

	

protected:

	//  ʱȭ
	void InitializeStage(void);

	//  ~
	void ReleaseStage(void);

	// 
	void CopyFrom( const CStage& rhs );


public:
	int m_nStageUID;   //  ȣ
	int m_nWidth;        //   ũ
	int m_nHeight;       //   ũ
	bool m_bClear;      //  Ŭ 
	int m_nMovementCount;  //  Ƚ( bClear == true ϶ Ƚ  )
	BYTE* m_pData;    //  
};
