// SMEView.cpp : CSMEView Ŭ 
//

#include "stdafx.h"
#include "SME.h"

#include "SMEDoc.h"
#include "SMEView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



// CSMEView

IMPLEMENT_DYNCREATE(CSMEView, CView)

BEGIN_MESSAGE_MAP(CSMEView, CView)
	// ǥ μ Դϴ.
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

// CSMEView /Ҹ

CSMEView::CSMEView()
{
	// TODO: ⿡  ڵ带 ߰մϴ.

}

CSMEView::~CSMEView()
{
}

BOOL CSMEView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CView::PreCreateWindow(cs);
}

// CSMEView ׸

void CSMEView::OnDraw(CDC* pDC)
{
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// Test Code
	CRect rc;
	GetClientRect( &rc );

	if( pDoc->m_packageManager.HasValidPackage() )
	{
		const CStage* pCurStage = pDoc->m_packageManager.GetPackage()->GetCurrentStage();

		if( pCurStage && pCurStage->HasValidStage() )
		{
			CString strFullLine;
			for( int y = 0 ; y < pCurStage->m_nHeight ; y++ )
			{
				CString str1Line;
				for( int x = 0 ; x < pCurStage->m_nWidth ; x++ )
				{
					CString str1C;
					str1C.Format( L"%c", pCurStage->GetCell(x,y) );

					str1Line += str1C;
				}
				strFullLine += str1Line;
			}

			pDC->DrawText( strFullLine, &rc, DT_LEFT | DT_TOP );
		}
	}
}


// CSMEView μ

BOOL CSMEView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ⺻ غ
	return DoPreparePrinting(pInfo);
}

void CSMEView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μϱ  ߰ ʱȭ ۾ ߰մϴ.
}

void CSMEView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μ   ۾ ߰մϴ.
}


// CSMEView 

#ifdef _DEBUG
void CSMEView::AssertValid() const
{
	CView::AssertValid();
}

void CSMEView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSMEDoc* CSMEView::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSMEDoc)));
	return (CSMEDoc*)m_pDocument;
}
#endif //_DEBUG


// CSMEView ޽ ó

void CSMEView::OnLButtonUp(UINT nFlags, CPoint point)
{
	CView::OnLButtonUp(nFlags, point);
}


void CSMEView::OnFileOpen()
{
	GetDocument()->m_packageManager.LoadPackage();
	GetDocument()->m_packageManager.GetPackage()->ProcessStage( SOP_NEW );

	Invalidate( FALSE );
}

void CSMEView::OnFileSave()
{
	GetDocument()->m_packageManager.SavePackage();

	Invalidate( FALSE );
}

void CSMEView::OnFileSaveAs()
{
	GetDocument()->m_packageManager.SaveAsPackage();

	Invalidate( FALSE );
}