// $Id: Package.h,v 1.23 2006/06/12 15:46:02 gyehongpark Exp $


#pragma once

#include"stage.h"
#include"DataType.h"
#include <list>
#include <string>
//using namespace std;

class Package
{
private:
	std::list<Stage*> m_stageList;

public:
	Package(void);
	~Package(void);
	int addStageAt(Stage* stage, const int position);
	int addStageAt(const std::string str = "default",
		const int position = LAST);

	int addStageAt(int row, int column, int position);


	int getStageCount(void);
	Stage* getStageAt(int position);
	const CString getStageInStringAt(int position);
	bool changeCell(const int level, const int row, const int column,
		const CellType cellType);

	void cutStageAt(const int nStage);
	void copyStageAt(const int nStage);
	int pasteStageAt(const int nStage);
	void deleteStageAt(const int nStage);

	void resize(const int position, const int row, const int column);
};
