// MainFrm.cpp : CMainFrame Ŭ 
//

#include "stdafx.h"
#include "SME.h"

#include "MainFrm.h"
#include ".\mainfrm.h"
#include "SMEDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_SETUP, OnUpdateFilePrintSetup)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLOSE, OnUpdateFileClose)
	ON_UPDATE_COMMAND_UI_RANGE(ID_STAGE_BEGIN, ID_STAGE_END, OnUpdateStageMove)
	ON_UPDATE_COMMAND_UI_RANGE(ID_STAGE_NEW, ID_STAGE_NEWSIZE, OnUpdateNewStage)
	ON_UPDATE_COMMAND_UI(ID_STAGE_RESIZE, OnUpdateStageResize)
	ON_UPDATE_COMMAND_UI_RANGE(ID_CELL_BG, ID_CELL_WALL, OnUpdateSelectCell)
	ON_UPDATE_COMMAND_UI_RANGE(ID_TOOL_SELECT, ID_TOOL_ERASER, OnUpdateSelectTool)
	ON_UPDATE_COMMAND_UI_RANGE(ID_STAGE_CUT, ID_STAGE_DELETE, OnUpdateStageEdit)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND_RANGE(ID_CELL_BG, ID_CELL_WALL, OnSelectCell)
	ON_COMMAND_RANGE(ID_TOOL_SELECT, ID_TOOL_ERASER, OnSelectTool)
END_MESSAGE_MAP()

static UINT indicators[] =
	{
	ID_SEPARATOR
	,   		//   ǥñ
	ID_INDICATOR_CAPS
	, ID_INDICATOR_NUM
	, ID_INDICATOR_SCRL
	, 
	};


// CMainFrame /Ҹ

CMainFrame::CMainFrame()
	{
	// TODO: ⿡  ʱȭ ڵ带 ߰մϴ.
	OnSelectTool(ID_TOOL_PEN);
	OnSelectCell(ID_CELL_FG);
	}

CMainFrame::~CMainFrame()
	{
	}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
	{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) || !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("   ߽ϴ.\n");
		return -1;  	//  ߽ϴ.
		}

	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators, sizeof(indicators) / sizeof(UINT)))
		{
		TRACE0(" ǥ  ߽ϴ.\n");
		return -1;  	//  ߽ϴ.
		}
	// TODO:   ŷ   Ϸ    Ͻʽÿ.
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	createCellBar();
	createDrawingToolBar();
	return 0;
	}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &cs)
	{
	if (!CFrameWnd::PreCreateWindow(cs))
		{
		return FALSE;
		}
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return TRUE;
	}


// CMainFrame 

#ifdef _DEBUG
void CMainFrame::AssertValid() const
	{
	CFrameWnd::AssertValid();
	}

void CMainFrame::Dump(CDumpContext &dc) const
	{
	CFrameWnd::Dump(dc);
	}

#endif //_DEBUG


// CMainFrame ޽ ó
void CMainFrame::createCellBar()
	{
	if (!m_wndCellBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) || !m_wndCellBar.LoadToolBar(IDR_CELL))
		{
		TRACE("Failed to create CellBar\n");
		return;
		}

	m_wndCellBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndCellBar, AFX_IDW_DOCKBAR_BOTTOM);
	}

void CMainFrame::createDrawingToolBar()
	{
	if (!m_wndDrawingToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_LEFT | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) || !m_wndDrawingToolBar.LoadToolBar(IDR_DRAWINGTOOL))
		{
		TRACE("Failed to create Drawing Bar\n");
		return;
		}

	m_wndDrawingToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndDrawingToolBar, AFX_IDW_DOCKBAR_LEFT);
	}

void CMainFrame::OnUpdateFileSave(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(GetActiveDocument()->IsModified());
	}

void CMainFrame::OnUpdateFileSaveAs(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsOpenedPackage());
	}

void CMainFrame::OnUpdateFilePrint(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	//pCmdUI->Enable(static_cast<CSMEDoc *>(GetActiveDocument())->IsOpenedPackage());
	// μ  .
	pCmdUI->Enable(FALSE);
	}

void CMainFrame::OnUpdateFilePrintPreview(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	//pCmdUI->Enable(static_cast<CSMEDoc *>(GetActiveDocument())->IsOpenedPackage());
	// μ  .
	pCmdUI->Enable(FALSE);
	}

void CMainFrame::OnUpdateFilePrintSetup(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	// μ  .
	pCmdUI->Enable(FALSE);
	}

void CMainFrame::OnUpdateFileClose(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsOpenedPackage());
	}

void CMainFrame::OnUpdateStageMove(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	CSMEDoc *pDoc = static_cast<CSMEDoc*>(GetActiveDocument());
	if (true == pDoc->IsOpenedPackage())
		{
		switch (pCmdUI->m_nID)
			{
			case ID_STAGE_BEGIN:
				pCmdUI->Enable((pDoc->getCurrentLevel() > 1) ? TRUE : FALSE);
				break;
			case ID_STAGE_PRE:
				pCmdUI->Enable((pDoc->getCurrentLevel() > 1) ? TRUE : FALSE);
				break;
			case ID_STAGE_NEXT:
				pCmdUI->Enable((pDoc->getCurrentLevel() < pDoc->getTotalLevel()) ? TRUE : FALSE);
				break;
			case ID_STAGE_END:
				pCmdUI->Enable((pDoc->getCurrentLevel() == pDoc->getTotalLevel()) ? FALSE : TRUE);
				break;
			}
		}
	else
		{
		pCmdUI->Enable(FALSE);
		}
	}

void CMainFrame::OnUpdateNewStage(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsOpenedPackage());
	}

void CMainFrame::OnUpdateStageResize(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsExistStage());
	}

void CMainFrame::OnSelectTool(UINT uID)
	{
	m_selectedToolID = uID;

	//CSMEDoc *pDoc = static_cast<CSMEDoc *>(GetActiveDocument());
	//if (0 != pDoc && true == pDoc->IsExistStage())
	//	{
	//	GetActiveDocument()->UpdateAllViews(NULL);
	//	}
	}

void CMainFrame::OnUpdateSelectTool(CCmdUI *pCmdUI)
	{
	CSMEDoc *pDoc = static_cast<CSMEDoc*>(GetActiveDocument());
	if (true == pDoc->IsExistStage())
		{
		pCmdUI->Enable();
		pCmdUI->SetCheck(getSelectedToolID() == pCmdUI->m_nID);
		}
	else
		{
		pCmdUI->Enable(FALSE);
		}
	}

void CMainFrame::OnSelectCell(UINT uID)
	{
	m_selectedCellID = uID;
	switch (m_selectedCellID)
		{
		case ID_CELL_BG:
			m_selectedCell = Stage::BG;
			break;
		case ID_CELL_BURDEN:
			m_selectedCell = Stage::BURDEN;
			break;
		case ID_CELL_BURDENTARGET:
			m_selectedCell = Stage::BURDENTARGET;
			break;
		case ID_CELL_FG:
			m_selectedCell = Stage::FG;
			break;
		case ID_CELL_PORTER:
			m_selectedCell = Stage::PORTER;
			break;
		case ID_CELL_PORTERTARGET:
			m_selectedCell = Stage::PORTERTARGET;
			break;
		case ID_CELL_TARGET:
			m_selectedCell = Stage::TARGET;
			break;
		case ID_CELL_WALL:
			m_selectedCell = Stage::WALL;
			break;
		}
	}

void CMainFrame::OnUpdateSelectCell(CCmdUI *pCmdUI)
	{
	CSMEDoc *pDoc = static_cast<CSMEDoc*>(GetActiveDocument());
	if (true == pDoc->IsExistStage())
		{
		pCmdUI->Enable();
		pCmdUI->SetCheck(getSelectedCellID() == pCmdUI->m_nID);
		}
	else
		{
		pCmdUI->Enable(FALSE);
		}
	}

void CMainFrame::OnUpdateStageEdit(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	BOOL enableUI = FALSE;
	switch (pCmdUI->m_nID)
		{
		case ID_STAGE_PASTE:
			if (static_cast<CSMEDoc*>(GetActiveDocument())->IsOpenedPackage() && IsClipboardFormatAvailable(CF_TEXT))
				{
				::OpenClipboard(GetActiveView()->GetSafeHwnd());
				HGLOBAL hmem = ::GetClipboardData(CF_TEXT);
				char *ptr = (char *) ::GlobalLock(hmem);
				char *stageString = new char [strlen(ptr) + 1];
				strcpy(stageString, ptr);
				::GlobalUnlock(hmem);
				::CloseClipboard();
				if (0 == strncmp(stageString, ";stage\n", strlen(";stage\n")))
					{
					enableUI = TRUE;
					}
				delete[] stageString;
				}
			break;
		default:
			enableUI = static_cast<CSMEDoc*>(GetActiveDocument())->IsExistStage();
			break;
		}
	pCmdUI->Enable(enableUI);
	}
void CMainFrame::OnUpdateEditUndo(CCmdUI *pCmdUI)
	{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	pCmdUI->Enable(static_cast<CSMEDoc*>(GetActiveDocument())->IsExistUndoData());
	}
